# Mandel-6502

Work-in-progress Mandelbrot fractal viewer for Atari 8-bit home computers. Mostly an excuse to write an integer multiplication routine for the 6502 for practice.

Goals:

* have fun learning 6502 assembly
* make an old machine do something inefficient as efficiently as possible.
* post cool screenshots of low-res fractals

Non-goals:

* maintain anything long-term (but feel free to copy/fork if you want to make major changes!)

Enjoy! I'll probably work on this off and on for the next few weeks until I've got it producing fractals.

-- brion, january 2023

## Current state

Basic rendering is functional, but no interactive behavior (zoom/pan) or benchmarking is done yet.

The 16-bit signed integer multiplication works; it takes two 16-bit inputs and emits one 32-bit output in the zero page, using the Atari OS ROM's floating point registers as workspaces. Inputs are clobbered.

The main loop is a basic add-and-shift, using 16-bit adds which requires flipping the sign of negative inputs (otherwise you'd have to add all those sign-extension bits). Runs in 470-780 cycles depending on input.

The mandelbrot calculations are done using 4.12-precision fixed point numbers. It may be possible to squish this down to 3.13.

Iterations are capped at 255.

## Next steps

Add a running counter of ms/px using the vertical blank interrupts as a timer. This'll show how further work improves it!

Check for cycles in (zx,zy) output when in the 'lake'; if values repeat, they cannot escape. This is a big time saver in fractint.

I may be able to do a faster multiply using tables of squares for 8-bit component multiplication.

## Deps and build instructions

I'm using `ca65` as a macro assembler, and have a Unix-style `Makefile` for building. Should work fairly easily on Linux and Mac. Might work on "raw" Windows but I use WSL for that.

Currently produces a `.xex` executable, which can be booted up in common Atari emulators and some i/o devices.
